package internal

import (
	"fmt"

	"go.uber.org/zap"
)

func NewLogger(prodConfig bool) (*zap.Logger, error) {
	logger, err := newZapConfig(prodConfig).Build()
	if err != nil {
		return nil, fmt.Errorf("config.Build: %w", err)
	}
	zap.ReplaceGlobals(logger)
	return logger, nil
}

func newZapConfig(prodConfig bool) zap.Config {
	if prodConfig {
		return zap.NewProductionConfig()
	}
	return zap.NewDevelopmentConfig()
}
