package model_test

import (
	"testing"
	"time"

	"gitea.dwysokinski.me/twhelp/sessions/internal/bundb/internal/model"
	"gitea.dwysokinski.me/twhelp/sessions/internal/domain"
	"github.com/google/uuid"
	"github.com/stretchr/testify/assert"
)

func TestAPIKey(t *testing.T) {
	t.Parallel()

	var id int64 = 123
	params, err := domain.NewCreateAPIKeyParams(uuid.NewString(), uuid.NewString(), 1)
	assert.NoError(t, err)

	result := model.NewAPIKey(params)
	result.ID = id

	apiKey := result.ToDomain()
	assert.Equal(t, id, apiKey.ID)
	assert.Equal(t, params.Name(), apiKey.Name)
	assert.Equal(t, params.Key(), apiKey.Key)
	assert.Equal(t, params.UserID(), apiKey.UserID)
	assert.WithinDuration(t, time.Now(), apiKey.CreatedAt, 10*time.Millisecond)
}
