package model_test

import (
	"strings"
	"testing"
	"time"

	"gitea.dwysokinski.me/twhelp/sessions/internal/bundb/internal/model"
	"gitea.dwysokinski.me/twhelp/sessions/internal/domain"
	"github.com/stretchr/testify/assert"
)

func TestUser(t *testing.T) {
	t.Parallel()

	var id int64 = 123
	params, err := domain.NewCreateUserParams("NAMEname")
	assert.NoError(t, err)

	result := model.NewUser(params)
	result.ID = id
	assert.Equal(t, strings.ToLower(params.Name()), result.NameLower)

	user := result.ToDomain()
	assert.Equal(t, id, user.ID)
	assert.Equal(t, params.Name(), user.Name)
	assert.WithinDuration(t, time.Now(), user.CreatedAt, 10*time.Millisecond)
}
