package model

import (
	"net/http"
	"time"
)

type Status string

const (
	StatusPass Status = "pass"
	StatusFail Status = "fail"
)

func (s Status) ToHTTPStatus() int {
	if s != StatusPass {
		return http.StatusFailedDependency
	}
	return http.StatusOK
}

type ComponentStatus struct {
	Status Status    `json:"status"`
	Time   time.Time `json:"time"`
}

type Checks map[string][]ComponentStatus

type ReadyResp struct {
	Status Status `json:"status"`
	Checks Checks `json:"checks"`
}
