package model

import (
	"time"

	"gitea.dwysokinski.me/twhelp/sessions/internal/domain"
)

type User struct {
	ID        int64     `json:"id"`
	Name      string    `json:"name"`
	CreatedAt time.Time `json:"createdAt" format:"date-time"`
} // @name User

func NewUser(u domain.User) User {
	return User{
		ID:        u.ID,
		Name:      u.Name,
		CreatedAt: u.CreatedAt,
	}
}

type GetUserResp struct {
	Data User `json:"data"`
} // @name GetUserResp

func NewGetUserResp(u domain.User) GetUserResp {
	return GetUserResp{Data: NewUser(u)}
}
