package model_test

import (
	"testing"
	"time"

	"gitea.dwysokinski.me/twhelp/sessions/internal/domain"
	"gitea.dwysokinski.me/twhelp/sessions/internal/router/rest/internal/model"
	"github.com/stretchr/testify/assert"
)

func TestNewUser(t *testing.T) {
	t.Parallel()

	user := domain.User{
		ID:        111,
		Name:      "Name 111",
		CreatedAt: time.Now(),
	}
	assertUser(t, user, model.NewUser(user))
}

func TestNewGetUserResp(t *testing.T) {
	t.Parallel()

	user := domain.User{
		ID:        111,
		Name:      "Name 111",
		CreatedAt: time.Now(),
	}
	assertUser(t, user, model.NewGetUserResp(user).Data)
}

func assertUser(tb testing.TB, du domain.User, ru model.User) {
	tb.Helper()

	assert.Equal(tb, du.ID, ru.ID)
	assert.Equal(tb, du.Name, ru.Name)
	assert.Equal(tb, du.CreatedAt, ru.CreatedAt)
}
